"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var watcher_1 = require("./watcher");
function asValue(value) {
    if (typeof value == "string") {
        if (value == "true")
            return true;
        if (value == "false")
            return false;
    }
    return value;
}
var CodeMirrorWatcher = (function (_super) {
    __extends(CodeMirrorWatcher, _super);
    function CodeMirrorWatcher() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.editors = {};
        return _this;
    }
    CodeMirrorWatcher.prototype.addEditorInstance = function (editorId, instanceId) {
        this.editors[editorId] = instanceId;
    };
    CodeMirrorWatcher.prototype.clearEditorInstance = function (editorId, instanceId) {
        // @FIXME: Need to clean up editors on removal
        console.warn("@FIXME: Need to clean up editors on removal.");
        this.editors[editorId] = instanceId;
    };
    CodeMirrorWatcher.prototype.setup = function () {
        var _this = this;
        this.html = this.program.attach("html");
        this.program
            .bind("CodeMirror editors are html elements.", function (_a) {
            var find = _a.find;
            var canvas = find("codemirror/editor");
            return [canvas.add({ tag: "html/element", tagname: "div" })];
        })
            .watch("Export editor instances.", function (_a) {
            var find = _a.find;
            var editor = find("codemirror/editor");
            var instance = find("html/instance", { element: editor });
            return [editor.add("instance", instance)];
        })
            .asDiffs(function (diffs) {
            for (var _i = 0, _a = diffs.adds; _i < _a.length; _i++) {
                var _b = _a[_i], editor = _b[0], _ = _b[1], instance = _b[2];
                _this.addEditorInstance(editor, instance);
            }
            for (var _c = 0, _d = diffs.removes; _c < _d.length; _c++) {
                var _e = _d[_c], editor = _e[0], _ = _e[1], instance = _e[2];
                _this.clearEditorInstance(editor, instance);
            }
        });
    };
    return CodeMirrorWatcher;
}(watcher_1.Watcher));
exports.CodeMirrorWatcher = CodeMirrorWatcher;
watcher_1.Watcher.register("codemirror", CodeMirrorWatcher);
//# sourceMappingURL=codemirror.js.map